#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <math.h>
#include <unistd.h>

pthread_mutex_t lock = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t condition = PTHREAD_COND_INITIALIZER;

int flag=0;

void * ping(void* spare)
{
	while(1)
	{
		sleep(2);
		pthread_mutex_lock(&lock);
		printf("Ping!\n");
		flag += 1;	
		pthread_cond_signal(&condition);
		pthread_mutex_unlock(&lock);
	}
}
void * pong(void* threadID)
{
	while(1)
	{
		pthread_mutex_lock(&lock);
		if(flag < 1)
		{
			pthread_cond_wait(&condition, &lock);
		}
		if(flag > 0)
		{
			printf("Pong! (%d)\n",(int)threadID);
			flag--;
		}
		pthread_mutex_unlock(&lock);
	}
}

int main(void)
{
	pthread_t thread1, thread2;
	pthread_create(&thread1, NULL, pong, (void*)1);
	pthread_create(&thread1, NULL, pong, (void*)2);
	pthread_create(&thread1, NULL, pong, (void*)3);
	pthread_create(&thread2, NULL, ping, NULL);
	pthread_join(thread1, NULL);
	pthread_join(thread2, NULL);
	return 0;
}
